#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "geometry.h"

main(int argc, char *argv[])
{
    P2D x0, x1, x2, ct;
    CIRC cr;
    int i;
    double s, r0, r1, r2, xx, yy, sq3;

    if(argc > 1) x0.x = atof(argv[1]);
    else x0.x = .5;
    if(argc > 2) x0.y = atof(argv[2]);
    else x0.y = 0.;
    if(argc > 3) r1 = atof(argv[2]);
    else r1 = 1.;
    sq3 = sqrt(3.);
    r2 = r1 * r1;
    s = atan2(x0.y, x0.x);
    r0 = sqrt(x0.x * x0.x + x0.y * x0.y);
    r1 = r2 / (r0 + 1.);
    x1.x = r1 * cos(s); x1.y = r1 * sin(s);
    r1 = r2 / (r0 - 1.);
    x2.x = r1 * cos(s); x2.y = r1 * sin(s);
    ct.x = (x1.x + x2.x) / 2.; ct.y = (x1.y + x2.y) / 2.;
    xx = x1.x - ct.x; yy = x1.y - ct.y;
    r1 = sqrt(xx * xx + yy * yy);
    printf("circle %f %f %f\n", ct.x, ct.y, r1);
    r1 = r2 / (r0 + 3.);
    x1.x = r1 * cos(s); x1.y = r1 * sin(s);
    r1 = r2 / (r0 - 3.);
    x2.x = r1 * cos(s); x2.y = r1 * sin(s);
    ct.x = (x1.x + x2.x) / 2.; ct.y = (x1.y + x2.y) / 2.;
    xx = x1.x - ct.x; yy = x1.y - ct.y;
    r1 = sqrt(xx * xx + yy * yy);
    printf("circle %f %f %f\ncolor 0 3 3\n", ct.x, ct.y, r1);
    r1 = r2 / (r0 + sq3);
    x1.x = r1 * cos(s); x1.y = r1 * sin(s);
    r1 = r2 / (r0 - sq3);
    x2.x = r1 * cos(s); x2.y = r1 * sin(s);
    ct.x = (x1.x + x2.x) / 2.; ct.y = (x1.y + x2.y) / 2.;
    xx = x1.x - ct.x; yy = x1.y - ct.y;
    r1 = sqrt(xx * xx + yy * yy);
    printf("circle %f %f %f\ncolor 0 0 3\n", ct.x, ct.y, r1);
    for(i = 0; i < 6; i++) {
	ct.x = x0.x + 2. * cos(i * M_PI / 3.); ct.y = x0.y + 2. * sin(i * M_PI / 3.);
	s = atan2(ct.y, ct.x);
	r0 = sqrt(ct.x * ct.x + ct.y * ct.y);
	r1 = r2 / (r0 + 1.);
	x1.x = r1 * cos(s); x1.y = r1 * sin(s);
	r1 = r2 / (r0 - 1.);
	x2.x = r1 * cos(s); x2.y = r1 * sin(s);
	ct.x = (x1.x + x2.x) / 2.; ct.y = (x1.y + x2.y) / 2.;
	xx = x1.x - ct.x; yy = x1.y - ct.y;
	r1 = sqrt(xx * xx + yy * yy);
	printf("circle %f %f %f\n", ct.x, ct.y, r1);
    }
    return 0;
}
