#include <stdio.h>
#define MAXN 100

typedef struct rat {
    int x, y, dx, dy;
} ratpt;

ratpt rp[MAXN];
int p, n;

int mul(int i, int j)
{
    int a, b, k, t;

    if(i == n) {
	if(j == n) return n;
	if(rp[j].dx == 0) return j;
	for(k = 0; k < n; k++) {
	    if(k == j) continue;
	    if(rp[j].x == rp[k].x) return k;
	}
    }
    if(j == n) {
	if(rp[i].dx == 0) return i;
	for(k = 0; k < n; k++) {
	    if(k == i) continue;
	    if(rp[i].x == rp[k].x) return k;
	}
    }
    if(i == j) {
	if((a = rp[i].dx) == 0) return n;
	b = rp[i].dy;
    }
    else {
	if(rp[i].x == rp[j].x) return n;
	a = rp[i].x - rp[j].x;
	b = rp[i].y - rp[j].y;
	t = a * rp[i].dy - b * rp[i].dx;
	if(t < 0) t *= -1;
	if((t % p) == 0) return i;
	t = a * rp[j].dy - b * rp[j].dx;
	if(t < 0) t *= -1;
	if((t % p) == 0) return j;
    }
    for(k = 0; k < n; k++) {
	if(k == j || k == i) continue;
	t = a * (rp[k].y - rp[i].y) - b * (rp[k].x - rp[i].x);
	if(t < 0) t *= -1;
	if((t % p) == 0) return k;
    }
    if(i != j) exit(0);
    return i;
}

main(int argc, char *argv[])
{
    int x, x2, x3, y, y2, rh, lh, i, j, o;

    if(argc == 1) p = 19;
    else p = atoi(argv[1]);
    if(argc < 3) o = 0;
    else o = atoi(argv[2]);
    n = 0;
    for(x = 0; x < p; x++) {
	x2 = x * x;
	x2 %= p;
	x3 = x2 * x;
	x3 %= p;
	if((rh = x3 - x) < 0) rh += p;
	for(y = 0; y < p; y++) {
	    y2 = y * y;
	    y2 %= p;
	    if((lh = y2 + y) >= p) lh -= p;
	    if(lh == rh) {
		rp[n].x = x; rp[n].y = y;
		rp[n].dy = (3 * x2 - 1 + p) % p;
		rp[n].dx = (2 * y + 1) % p;
		fprintf(stderr, "%d:(%d, %d) - (%d, %d)\n", n, x, y, rp[n].dx, rp[n].dy);
		n++;
		if(n > MAXN) break;
	    }
	}
    }
    fprintf(stderr, "%d\n", n);
    for(i = 0; i <= n; i++) {
	for(j = 0; j <= n; j++) {
	    printf("%d ", mul(o, mul(i, j)));
	}
	printf("\n");
    }
    return 0;
}

