#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define MAXN 400

typedef struct {
    double r, i;
} CPX;

struct cm {
    CPX cf[4];
} a[MAXN];


struct cm mcm(struct cm a, struct cm b);
void display(struct cm a);
int alex(struct cm a[], int n);
int cutstowd(char *s, char *a[]);
int getline(char *s);
CPX atocpx(char *s);

main(int argc, char *argv[])
{
    int i, j, k, l, m = 0, n = 4;
    char s[256], *ps[10];

    if(argc > 1) n = atoi(argv[1]) + 1;
    a[0].cf[0].r = 1.; a[0].cf[0].i = 0.; 
    a[0].cf[1].r = 0.; a[0].cf[1].i = 0.; 
    a[0].cf[2].r = 0.; a[0].cf[2].i = 0.; 
    a[0].cf[3].r = 1.; a[0].cf[3].i = 0.; 
    for(i = 1; i < n; i++) {
	for(j = 0; j < 4; ) {
	    if(getline(s) == 0) continue;
	    l = cutstowd(s, ps);
	    for(k = 0; k < l; k++) {
		a[i].cf[j++] = atocpx(ps[k]);
		if(j == 4) break;
	    }
	}
    }

    for(i = 0; i < n; i++) display(a[i]);
    for( ; ; ) {
	for(i = 0; i <= m; i++) {
	    a[n] = mcm(a[i], a[m]);
	    if(alex(a, n) == -1) {
		fprintf(stderr, "%d:\n", n);
		display(a[n]);
		n++;
		if(n >= MAXN) exit(0);
	    }
	}
	if(++m == n) break;
    }
    for(i = 0; i < n; i++) {
	for(j = 0; j < n; j++) {
	    a[n] = mcm(a[i], a[j]); 
	    printf("%d ", alex(a, n));
	}
	printf("\n");
    }
    return 0;
}

void display(struct cm a)
{
    fprintf(stderr, "%f + i %f   ", a.cf[0].r, a.cf[0].i);
    fprintf(stderr, "%f + i %f\n", a.cf[1].r, a.cf[1].i);
    fprintf(stderr, "%f + i %f   ", a.cf[2].r, a.cf[2].i);
    fprintf(stderr, "%f + i %f\n", a.cf[3].r, a.cf[3].i);
    fprintf(stderr, "\n");
}

struct cm mcm(struct cm a, struct cm b)
{
    struct cm c;

    c.cf[0].r = a.cf[0].r * b.cf[0].r - a.cf[0].i * b.cf[0].i + a.cf[1].r * b.cf[2].r - a.cf[1].i * b.cf[2].i;
    c.cf[0].i = a.cf[0].r * b.cf[0].i + a.cf[0].i * b.cf[0].r + a.cf[1].r * b.cf[2].i + a.cf[1].i * b.cf[2].r;
    c.cf[1].r = a.cf[0].r * b.cf[1].r - a.cf[0].i * b.cf[1].i + a.cf[1].r * b.cf[3].r - a.cf[1].i * b.cf[3].i;
    c.cf[1].i = a.cf[0].r * b.cf[1].i + a.cf[0].i * b.cf[1].r + a.cf[1].r * b.cf[3].i + a.cf[1].i * b.cf[3].r;
    c.cf[2].r = a.cf[2].r * b.cf[0].r - a.cf[2].i * b.cf[0].i + a.cf[3].r * b.cf[2].r - a.cf[3].i * b.cf[2].i;
    c.cf[2].i = a.cf[2].r * b.cf[0].i + a.cf[2].i * b.cf[0].r + a.cf[3].r * b.cf[2].i + a.cf[3].i * b.cf[2].r;
    c.cf[3].r = a.cf[2].r * b.cf[1].r - a.cf[2].i * b.cf[1].i + a.cf[3].r * b.cf[3].r - a.cf[3].i * b.cf[3].i;
    c.cf[3].i = a.cf[2].r * b.cf[1].i + a.cf[2].i * b.cf[1].r + a.cf[3].r * b.cf[3].i + a.cf[3].i * b.cf[3].r;
    return c;
}

int alex(struct cm a[], int n)
{
    int i, j;
    double gosa;

    for(i = 0; i < n; i++) {
	for(j = 0; j < 4; j++) {
	    if((gosa = a[i].cf[j].r - a[n].cf[j].r) >.001 || gosa < -.001) break;
	    if((gosa = a[i].cf[j].i - a[n].cf[j].i) >.001 || gosa < -.001) break;
	}
	if(j == 4) return i;
    }
    return -1;
}
