#include <stdio.h>
#include <stdlib.h>

int *a, *b, *s, *gt, *invgt;
int degree, nofsg, nofgt;

main(argc,argv)
	int argc;
	char *argv[];
{
	extern int *a, *b, *s, degree, nofsg, nofgt, *gt, *invgt;
	void ex();
	int i, j;

	nofsg = 0;
	if(argc>1) degree = atoi(argv[1]);
	else scanf("%d",&degree);
	if(degree < 2) {
		printf("2 <= degree\n");
		exit(0);
	}
	if((a = malloc(4 * degree * degree)) == NULL) {
		printf("There is not enough memory\n");
		exit(0);
	}
	if((gt = malloc(4 * degree)) == NULL) {
		printf("There is not enough memory\n");
		exit(0);
	}
	if((invgt = malloc(4 * degree)) == NULL) {
		printf("There is not enough memory\n");
		exit(0);
	}
	if((b = malloc(4 * degree)) == NULL) {
		printf("There is not enough memory\n");
		exit(0);
	}
	if((s = malloc(4 * degree)) == NULL) {
		printf("There is not enough memory\n");
		exit(0);
	}
	for(i = 0 ; i < degree; i++){
		printf("%d:", i);
		for(j = 0; j < degree; j++)
			scanf("%d",a + i * degree + j);
	}
/*	for(i = 0; i < degree* degree; i++) printf("%d ", *(a + i));
*/	printf("\n");
	nofgt = generators(a, gt, degree);
/*	for(i = 0; i< nofgt; i++) printf("%d ", *(gt + i));
	printf("\n");
*/	for(i = 0; i< nofgt; i++) *(invgt + i) = inversel(a, degree, *(gt + i));
/*	for(i = 0; i< nofgt; i++) printf("%d ", *(invgt + i));
	printf("\n");
*/	ex((int)0, (int)0);
	printf("The number of the normal subgroups is %d\n", nofsg);
	free(a);
	free(b);
	free(s);
	free(gt);
	free(invgt);
}

void ex(p, m0)
	int p, m0;
{
	extern int *a, *b, *s, degree, nofsg, nofgt, *gt, *invgt;
	int i, j, l, m, n, f, *c;
	void ex(), quotientgr();

/*	printf("ex((%d,%d) is called\n", p,m0);
*/	if((c = malloc(4 * degree)) == NULL) return;
	for(j = 0; j < degree; j++) *(c + j) = 0;
	for(j = 0; j < m0; j++) *(c + *(s + j)) = 1;
/*	for(i = 0; i < degree; i++) printf("%d ", *(c + i));
	printf("\n");
*/	for(; p < degree; p++) {
		f = 0;
		if(*(c + p) == 1) continue;
		for(j = 0; j < degree; j++) *(b + j) = *(c + j);
		*(s + (n = m = m0)) = p;
		*(b + p) = 1;
		for(; m <= n; m++) {
			for(j = 0; j < nofgt; j++) {
				if(*(b + (l = *(a + *(a + *(invgt + j) * degree + *(s + m)) * degree + *(gt + j)))) == 0) {
					if(l < p) break;
					*(b + l) = 1; n++; *(s + n) = l;
				}
			}
			if(j < nofgt) {
				f = 1;
				break;
			}
			for(j = 0; j <= m; j++) {
				if(*(b + (l = *(a + *(s + m) * degree + *(s + j)))) == 0) {
					if(l < p) break;
					*(b + l) = 1; n++; *(s + n) = l;
				}
				if(*(b + (l = *(a + *(s + j) * degree + *(s + m)))) == 0) {
					if(l < p) break;
					*(b + l) = 1; n++; *(s + n) = l;
				}
			}
			if(j <= m) {
				f = 1;
				break;
			}
		}
/*		for(j = 0; j <= n; j++) printf("%d ", *(s + j));
		printf("\n");
		for(i = 0; i < degree; i++) printf("%d ", *(b + i));
		printf("n = %d, m = %d\n", n, m);
*/		if(f == 1) continue;
		nofsg++;
		printf("%d : ", nofsg);
		for(j = 0; j <= n; j++) printf("%d ", *(s + j));
		printf("\n");
		if(n >= 1) quotientgr(a, b, degree);
		ex(p + 1, n + 1);
	}
	free(c);
	return;
}

int generators(a,g,n)
	int a[],g[],n;
{
	int i, *d, dd, gg, l=0;
	short *f;

	if((d = malloc(4 * degree)) == NULL) return -1;
	if((f = malloc(2 * degree)) == NULL) return -1;
	for(i = 0; i < n; i++) *(f + i)=0;
	fddeg(a, d, n);
	for( ; ; ){
		for(dd = i = 0; i < n; i++)
			if(*(f + i) == 0 && *(d + i) > dd) dd = *(d + (gg = i));
		if(dd == 0) break;
		*(f + (g[l++] = gg)) = 1;
		if(generated(a, n, f) == n) break;
	}
	free(d);
	free(f);
	return l;
}

int fddeg(a,b,n)
	int a[], b[], n;
{
	int i, j, x;

	for(i = 0; i < n; i++){
		for(x = i, j = 1; j <= n+1; j++){
			if(x == 0) {
				b[i] = j;
				break;
			}
			x=a[x*n + i];
		}
		if(j == n+1) return -1;
	}
	return 1;
}

int generated(a,n,s)
	int a[], n;
	short s[];
{
	int i, j, f, x, m;
	do{
		f = 0;
		for(i = 0; i < n; i++){
			if(s[i] == 1){
				if(s[x = inversel(a, n, i)] == 0){
					s[x] = 1; f = 1;
				}
				for(j = 0; j < n; j++){
					if(s[j] == 1){
						if(s[x = a[i*n + j]] == 0) {
							s[x] = 1; f = 1;
						}
					}
				}
			}
		}
	}while(f > 0);
	for(m = i = 0; i < n; i++) if(s[i] == 1) m++;
	return m;
}

int inversel(a, n, l)
	int a[], n, l;
{
	int i;
	for(i = 0; i < n; i++)
		if(a[i*n + l] == 0) return i;
	return -1;
}

void quotientgr(a, f, n)
	int a[], f[], n;
{
	int *f2, i, j, ns = 0, nq = 0, *r, d;
	int *qg;
	void dispm();

	if((qg = malloc(4 * n * n)) == NULL) return;
	if((f2 = malloc(4 * n)) == NULL) return;
	if((r = malloc(4 * n)) == NULL) return;
	for(i=0;i<n;i++){
		if(f[i]>0){
			*(f2 + i) = 0; ns++; *r = i;
		}
		else *(f2 + i) = -1;
	}
	nq = n/ns; d = 1;
	for(i = 0; i < n; i++){
		if(*(f2 + i) < 0){
			*(r + d) = i;
			for(j = 0; j < n; j++)
				if(*(f2 + j) == 0)	*(f2 + a[i*n+j]) = d;
			d++;
		}
	}
/*	printf("%d=%d\n", d, nq); */
	if(d != nq) printf("matigai\n");
	for(i = 0; i < nq; i++)
		for(j = 0; j < nq; j++)
			*(qg + i * nq + j ) = *(f2 + a[*(r + i)*n + *(r + j)]);
	dispm(qg, nq);
	free(qg);
	free(f2);
	free(r);
}

void dispm(a,n)
	int a[], n;
{
	int i, j;
	for(i = 0; i < n; i++){
		for(j = 0; j < n; j++)
			printf("%d ",a[i*n + j]);
		printf("\n");
	}
}

