#include "hbg.h"
#include <math.h>

void READ(Pl *p)
{
    scanf("%lf%lf%lf", &p->a, &p->b, &p->c);
}

void WRITE(Pl p)
{
    double d = p | p, a2b2 = p.a * p.a + p.b * p.b, c2 = p.c * p.c;

    if(d > 0) {
        double s, t, r;

	if(c2 < a2b2 * .00001) {
	    double d = sqrt(a2b2), x0 = p.b / d, y0 = -p.a / d;

	    printf("connect %f %f %f %f\n", x0, y0, -x0, -y0);
	}
	else {
	    if(p.c > 0) {
	        r = .5 * sqrt(d) / p.c;
		t = atan2(p.b, p.a);
	    }
	    else {
	        r = -.5 * sqrt(d) / p.c;
		if((t = atan2(p.b, p.a)) < 0) t += M_PI;
		   else t -= M_PI;
	    }
	    s = atan2(1., r);
	    printf("circle %f %f %f %f %f\n", -.5 * p.a / p.c, -.5 * p.b / p.c, r, (t - s) * 64. * 180. / M_PI, s * 128. * 180. / M_PI);
	}
    }
    else {
        double r;

	if(a2b2 < c2 * .000001) printf("disk 0. 0. .02\n");
	else {
	    if(p.c > 0) r = -2. * p.c + sqrt(-d);
	    else r = -2. * p.c - sqrt(-d);
	    r /= a2b2;
	    printf("disk %f %f .02\n", p.a * r, p.b * r);
	}
    }
}

Pl operator *(Pl p, Pl q)
{
    Pl r;

    r.a = 4. * (p.b * q.c - p.c * q.b);
    r.b = 4. * (p.c * q.a - p.a * q.c);
    r.c = p.b * q.a - p.a * q.b;
    return r;
}

Pl operator *(double t, Pl q)
{
    Pl r;

    r.a = t * q.a;
    r.b = t * q.b;
    r.c = t * q.c;
    return r;
}

Pl operator /(Pl p, double t)
{
    Pl r;

    r.a = p.a / t;
    r.b = p.b / t;
    r.c = p.c / t;
    return r;
}

double operator |(Pl p, Pl q)
{
    return p.a * q.a + p.b * q.b - 4. * p.c * q.c;
}

Pl operator +(Pl l, Pl m)
{
    double l2, m2;
    Pl n;

    /*
    if((l2 = l | l) > 0) l2 = sqrt(l2);
    else l2 = sqrt(-l2);
    if((m2 = m | m) > 0) m2 = sqrt(m2);
    else m2 = sqrt(-m2);
    n.a = l.a / l2 + m.a / m2;
    n.b = l.b / l2 + m.b / m2;
    n.c = l.c / l2 + m.c / m2;
    */
    n.a = l.a + m.a;
    n.b = l.b + m.b;
    n.c = l.c + m.c;
    return n;
}

Pl operator -(Pl l, Pl m)
{
    double l2, m2;
    Pl n;

    /*
    if((l2 = l | l) > 0) l2 = sqrt(l2);
    else l2 = sqrt(-l2);
    if((m2 = m | m) > 0) m2 = sqrt(m2);
    else m2 = sqrt(-m2);
    n.a = l.a / l2 - m.a / m2;
    n.b = l.b / l2 - m.b / m2;
    n.c = l.c / l2 - m.c / m2;
    */
    n.a = l.a - m.a;
    n.b = l.b - m.b;
    n.c = l.c - m.c;
    return n;
}

Pl operator /(Pl l, Pl m)
{
    Pl n;
    double t;
    t = 2. * (l | m) / (m | m);
    n.a = l.a - t * m.a;
    n.b = l.b - t * m.b;
    n.c = l.c - t * m.c;
    return n;
}
